def listMinors (n):
    N = Set(range (n))
    out = []
    for I in N.subsets(2):
        for L in N.difference(I).subsets():
            out.append ( [ [I[0]]+list(L), [I[1]]+list(L) ]  )
    return out

m4 = listMinors(4)

def listToMatrix (L):
    # The assumed ordering is b12, b13, b14, b23, b24, b34
    return matrix ([[1,L[0],L[1],L[2]],
                    [L[0],1,L[3],L[4]],
                    [L[1],L[3],1,L[5]],
                    [L[2],L[4],L[5],1]])

def computeOrientedGaussoid (M):
    gaussoid = ""
    for i in range (len(m4)):
        R = m4[i][0]
        C = m4[i][1]
        d = M.matrix_from_rows_and_columns(R,C).determinant()
        if d > 0: 
            gaussoid += "+"
        elif d==0:
            gaussoid += "0"
        else:
            gaussoid += "-"
    return gaussoid

def checkPrincipalMinorsPositive (M):
    for S in subsets (range(4)):
        if M.matrix_from_rows_and_columns(S,S).determinant() <= 0 :
            return false
    return true

def checkTable (filename):
    f = open(filename)
    for i, l in enumerate(f):
        i += 1
        s = l.split ("\t")
        g = s[0]
        print "Matrix #%02d" % i,
        if s[1].strip() == "none":
            print "none -- skipping"
            continue
        def readFloat (s):
            # https://stackoverflow.com/a/9407667
            import __future__
            return eval(compile(s.strip(), '<string>', 'eval', __future__.division.compiler_flag))
        bs = map(readFloat, s[1].split(","))
        M = listToMatrix (bs)
        if not checkPrincipalMinorsPositive (M):
            print "is NOT positive definite"
            continue
        G = computeOrientedGaussoid (M)
        print "realizes %s ..." % G,
        if g == G:
            print "CORRECT"
        else:
            print "INCORRECT"

checkTable ("table2.txt")

# vim: ts=4 expandtab softtabstop=4
